/****** Object:  UserDefinedFunction [dbo].[fn_SqlToCSharpTypeName]    Script Date: 11/28/2013 12:53:11 PM ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO


create function [dbo].[fn_SqlToCSharpTypeName] (
	@SqlType varchar(50)
) returns varchar(50) as
begin

	return
	case @SqlType
	when 'bigint' then 'Int64'
	when 'binary' then 'Byte[]'
	when 'bit' then 'bool'
	when 'char' then 'string'
	when 'date' then 'DateTime'
	when 'datetime' then 'DateTime'
	when 'datetime2' then 'DateTime'
	when 'datetimeoffset' then 'DateTimeOffset'
	when 'decimal' then 'Decimal'
	when 'float' then 'double'
	when 'geography' then 'string'
	when 'geometry' then 'string'
	when 'hierarchyid' then 'int'
	when 'image' then 'Byte[]'
	when 'int' then 'int'
	when 'money' then 'Decimal'
	when 'nchar' then 'string'
	when 'ntext' then 'string'
	when 'numeric' then 'Decimal'
	when 'nvarchar' then 'string'
	when 'real' then 'double'
	when 'smalldatetime' then 'DateTime'
	when 'smallint' then 'Int16'
	when 'smallmoney' then 'Decimal'
	when 'sql_variant' then 'object'
	when 'sysname' then 'string'
	when 'text' then 'string'
	when 'time' then 'DateTime'
	when 'timestamp' then 'Byte[]'
	when 'tinyint' then 'Byte'
	when 'uniqueidentifier' then 'Guid'
	when 'varbinary' then 'Byte[]'
	when 'varchar' then 'string'
	when 'xml' then 'string'
	end
end

GO


/****** Object:  StoredProcedure [dbo].[sys_CodeForSP]    Script Date: 11/28/2013 12:49:52 PM ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO


/*
exec sys_CodeForSP 'ta_CustomerLoad'
*/

CREATE procedure [dbo].[sys_CodeForSP]
	@SPName varchar(100)
with execute as owner
as

	select
		CSharp = 'public ' + dbo.fn_SqlToCSharpTypeName(t.Name) + ' ' + substring(c.Name, 2, len(c.Name)) + ' { get; set; }',
		ParmList = c.Name + ' '
			+ case t.Name when 'varchar' then 'varchar(' + convert(varchar(5), case when c.Length = -1 then 'max' else CONVERT(varchar(5), c.Length) end) + ')'
				when 'nvarchar' then 'nvarchar(' + convert(varchar(5), c.Length) + ')'
				when 'char' then 'char(' + convert(varchar(5), c.Length) + ')'
				when 'nchar' then 'nchar(' + convert(varchar(5), c.Length) + ')'
				when 'datetime2' then 'datetime2(7)'
				when 'datetimeoffset' then 'datetimeoffset(7)'
				when 'varbinary' then 'varbinary(' + convert(varchar(5), case when c.Length = -1 then 'max' else CONVERT(varchar(5), c.Length) end) + ')'
				else t.Name end
			+ ',',
		FieldList = substring(c.Name, 2, len(c.Name)) + ',',
		ValueList = c.Name + ',',
		UpdateList = substring(c.Name, 2, len(c.Name)) + ' = ' + c.Name + ',',
		o.Name As TableName,
		c.Name as ColumnName,
		t.Name As Type,
		c.Length,
		c.xprec,
		c.IsNullable,
		AutoIncrement = case when t.name = 'timestamp' then 1
						when c.status = 128 then 1 else 0 end
	from
		SysColumns c
		join SysObjects o on o.id = c.id and o.xtype = 'P'
		join SysTypes t on c.xtype = t.xtype and c.xusertype = t.xusertype
    where
       o.Name = @SPName
       --and IsOutParam = 1
    order by
		c.ColOrder

GO


/****** Object:  StoredProcedure [dbo].[sys_CodeForTable]    Script Date: 11/28/2013 12:50:21 PM ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO


/*
exec sys_CodeForTable 'Customer'
*/

CREATE procedure [dbo].[sys_CodeForTable]
	@TableName varchar(100)
with execute as owner
as

	select
		CSharp = 'public ' + dbo.fn_SqlToCSharpTypeName(t.Name) + ' ' + c.Name + ' { get; set; }',
		SqlParms = '@' + c.Name + ' '
			+ case t.Name when 'varchar' then 'varchar(' + convert(varchar(5), case when c.Length = -1 then 'max' else CONVERT(varchar(5), c.Length) end) + ')'
				when 'nvarchar' then 'nvarchar(' + convert(varchar(5), c.Length) + ')'
				when 'char' then 'char(' + convert(varchar(5), c.Length) + ')'
				when 'nchar' then 'nchar(' + convert(varchar(5), c.Length) + ')'
				when 'datetime2' then 'datetime2(7)'
				when 'datetimeoffset' then 'datetimeoffset(7)'
				when 'varbinary' then 'varbinary(' + convert(varchar(5), case when c.Length = -1 then 'max' else CONVERT(varchar(5), c.Length) end) + ')'
				else t.Name end
			+ ',',
		FieldList = c.Name + ',',
		ParmList = '@' + c.Name + ',',
		UpdateList = c.Name + ' = @' + c.Name + ',',
		o.Name As TableName,
		c.Name as ColumnName,
		t.Name As Type,
		c.Length,
		c.xprec,
		c.IsNullable,
		AutoIncrement = case when t.name = 'timestamp' then 1
						when c.status = 128 then 1 else 0 end,
		*
	from
		SysColumns c
		join SysObjects o on o.id = c.id and o.xtype = 'U'
		join SysTypes t on c.xtype = t.xtype and c.xusertype = t.xusertype
    where
       o.Name = @TableName
       --and IsOutParam = 1
    order by c.ColOrder

GO


/****** Object:  StoredProcedure [dbo].[sys_ExtendedProperty]    Script Date: 11/28/2013 12:50:38 PM ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO


/*
exec sys_ExtendedProperty 'AllowsDirectSql'
*/

CREATE procedure [dbo].[sys_ExtendedProperty]
	@PropertyName varchar(100)
with execute as owner
as

	select value from sys.extended_properties where name = @PropertyName

GO



/****** Object:  StoredProcedure [dbo].[sys_ParametersForSP]    Script Date: 11/28/2013 12:50:52 PM ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO


CREATE procedure [dbo].[sys_ParametersForSP]
	@SPName varchar(100)
with execute as owner
as

Select
	SPName = o.Name,
	Name = SUBSTRING(c.Name, 2, LEN(c.Name)),
	Type = t.Name,
	c.IsOutParam,
	c.Length,
	c.xprec,
	c.IsNullable,
	AutoIncrement = case when t.name = 'timestamp' then 1
					when c.status = 128 then 1 else 0 end
From
	SysColumns c
	join SysObjects o on o.id = c.id and o.xtype = 'P'
	join SysTypes t on c.xtype = t.xtype and c.xusertype = t.xusertype
Where
   o.Name = @SPName
   --and IsOutParam = 1
Order By
	c.ColOrder

GO


/****** Object:  StoredProcedure [dbo].[sys_StructureForTable]    Script Date: 11/28/2013 12:51:07 PM ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO


/*
exec sys_StructureForTable 'Customer'
*/

CREATE procedure [dbo].[sys_StructureForTable]
	@TableName varchar(100)
with execute as owner
as

	Select
		TableName = o.Name,
		c.Name,
		Type = t.Name,
		NETType = dbo.fn_SqlToCSharpTypeName(t.Name),
		c.Length,
		c.xprec,
		c.IsNullable,
		AutoIncrement = case when t.name = 'timestamp' then 1
						when c.status = 128 then 1 else 0 end
	From
		SysColumns c
		join SysObjects o on o.id = c.id and o.xtype = 'U'
		join SysTypes t on c.xtype = t.xtype and c.xusertype = t.xusertype
    Where
       o.Name = @TableName
       --and IsOutParam = 1
    Order By c.ColOrder

GO
